// Fill out your copyright notice in the Description page of Project Settings.


#include "PilotCameraShake.h"
#include "MonolithCharacter.h"
#include "MonolithPlayerController.h"
#include "MoveState.h"

void UPilotCameraShake::BeginPlay()
{
	Super::BeginPlay();
	// For some reason camera shakes dont override tick :((
	GetWorld()->GetTimerManager().SetTimer(TickHandle, this
		, &UPilotCameraShake::UpdateCameraShake, 0.25f, true);
}

bool UPilotCameraShake::TrySetMoveState()
{
	AMonolithCharacter* PlayerChar = Cast<AMonolithCharacter>
		(
			Cast<AMonolithPlayerController>(GetWorld()->GetFirstPlayerController())->GetPawn()
		);
	if ( PlayerChar == nullptr) return false;
	MoveState  = &PlayerChar->MoveState;
	return MoveState != nullptr;
}

void UPilotCameraShake::UpdateCameraShake()
{
	if (CantUpdate()) return;

	if (!MoveState->Is(GROUNDED))
	{
		if (CurrentState == Floating) return;
		CurrentState = Floating;
		SetCameraShakeBase(FloatingShake);
	}
	else if (MoveState->Is(SPRINT))
	{
		if (CurrentState == Running) return;
		CurrentState = Running;
		SetCameraShakeBase(RunningShake);
	}
	else if (MoveState->Is(STILL))
	{
		if (CurrentState == Idling) return;
		CurrentState = Idling;
		SetCameraShakeBase(IdleShake);		
	}
	else
	{
		if (CurrentState == Walking) return;
		CurrentState = Walking;
		SetCameraShakeBase(WalkingShake);
	}
}

void UPilotCameraShake::SetCameraShakeBase(TSubclassOf<UCameraShakeBase> ShakeBase)
{
	StopAllCameraShakes();
	StartCameraShake(ShakeBase);
}
